/**
 * Buddyexpress Desk
 *
 * @package   Bdesk
 * @author    Buddyexpress Core Team <admin@buddyexpress.net
 * @copyright 2014 BUDDYEXPRESS NETWORKS.
 * @license   Buddyexpress Public License http://www.buddyexpress.net/Licences/bpl/ 
 * @link      http://labs.buddyexpress.net/bdesk.b
 */

tinymce.PluginManager.add("bdesk_photo", function (editor, f) {
    /**
     * Setup buttons for Bdesk Editor
     * @lastchange: $arsalanshah
     */
    editor.addButton("bdesk_photo", {
      icon: 'image',
      title: 'Image Embed Upload',
      cmd: "bdesk_photo"
    });

    /**
     * Init the plugin
     * @lastchange $arsalanshah
     */
    editor.addCommand("bdesk_photo", function () {
        var _showError = function(container, message) {
            var id = 'ms-bdesk-message';
            var error = document.createElement('span');
            var oldError = document.getElementById(id);

            error.id = id;
            error.className = 'validation-failed';
            error.innerHTML = message;

            if (oldError) {
                container.removeChild(oldError);
            }

            container.appendChild(error);
        };

        var isMobile = document.body.classList.contains('mobile-version');

        editor.windowManager.open({
            //text for dialog
            title: "Embed an image",
            width: isMobile ? 290 : 450,
            //location:
            height: 95,
            //we need a to put a base64 encode image into texteditor
            html: '<div class="mce-bdesk">' +
                '<input ' +
                    'type="file" ' +
                    'class="input mce-bdesk-image" ' +
                    'name="bdesk_image" ' +
                    'id="image_embed" ' +
                    'accept="image/x-png, image/gif, image/jpeg"' +
                '>' +
            '</div>',
            buttons: [{
                text: "Insert",
                subtype: "primary",
                /**
                 * Triger a OnClick
                 * @lastchange: $arsalanshah
                 */
                onclick: function () {
                    if (window.File && window.FileReader && window.FileList && window.Blob) {
                        var message = null;
                        var image = document.getElementsByName("bdesk_image")[0];
                        var imagefile = image.files;
                        var class_filereader = new FileReader();

                        if (!imagefile.length) {
                            message =  'No File selected.';
                        } else if (imagefile[0].size > 1048576) {
                            message = 'Allowed maximum size is 1M.';
                        }

                        if (message) {
                            _showError(image.parentElement, message);
                            return;
                        }

                        class_filereader.onload = function (base64) {
                            imgData = base64.target.result;
                            var img = new Image();
                            img.src = imgData;

                            editor.execCommand("mceInsertContent", false, "<img src='" + imgData + "' />");
                        };

                        /**
                         * Log errors
                         * @lastchange: $arsalanshah
                         */
                        class_filereader.onerror = function (err) {
                            console.log("error", err);
                            console.log(err.getMessage());
                        };

                        class_filereader.readAsDataURL(imagefile[0]);
                    } else {
                        alert("Please change your browser to modern one");
                    }
                    (this).parent().parent().close();
                }
            },
            {
                text: "Close",
                subtype: "default",
                onclick: function () {
                    (this).parent().parent().close();
                }
            }],
        });
    });

    /**
     * Setup Insert buttons for Bdesk Editor Dialog
     * @lastchange: $arsalanshah
     */
    editor.addMenuItem("bdesk_photo", {
        cmd: "bdesk_photo",
        context: "insert",
        text: 'Embed Image',
        icon: 'image',
    });
});
